require 'node'

local function trace(a,b,c,d) return end

function main(Data) 
   local Msg, Name = hl7.parse{data= Data, vmd ='demo.vmd'}
   local Out = hl7.message{name = Name, vmd ='demo.vmd'}

   Out:mapTree(Msg)
   trace(Msg)
   trace(Out)
      
   Out.PID:setMinFields(26)
   trace(Out)
   trace(Out:S())
   
   -- FYI code below showing isLeaf()
   -- mimics recursion through a tree
   Out.PID[9]:isLeaf()
   Out.PID[9][1]:isLeaf()
   Out.PID[9][1][1]:isLeaf()
   Out.PID[9][1][1][1]:isLeaf()
   -- test a leaf
   Out.PID[8]:isLeaf()
   -- why the error?
   Out.PID[8][1]:isLeaf()
   Out.PID[999]:isLeaf() -- CLUE: try this line
end